unit Projects;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, Grids, ComCtrls, Dialogs, FileCtrl,FileUtility;

type
  TPrjDlg = class(TForm)
    Panel1: TPanel;
    CancelBtn: TButton;
    OKBtn: TButton;
    Panel3: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    strgrdPrjs: TStringGrid;
    Panel2: TPanel;
    btnNew: TBitBtn;
    btnDel: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure btnDelClick(Sender: TObject);
    procedure btnNewClick(Sender: TObject);
    procedure strgrdPrjsDblClick(Sender: TObject);
    procedure strgrdPrjsKeyPress(Sender: TObject; var Key: Char);
    procedure OKBtnClick(Sender: TObject);
    procedure FillstrgrdPrj;
  private
    { Private declarations }
    procedure Reset_PrjStrGrid(ColNum,RowNum:integer; ClearData:Boolean);
  public

    { Public declarations }
  end;

var
  PrjDlg: TPrjDlg;

const
  RunAry: Array[0..1] of string=('No','Yes');

implementation
uses Main;
{$R *.DFM}




procedure TPrjDlg.FillstrgrdPrj;
var
  icol,irow:integer;
  curP:Prjptr;
begin

  icol:=4; // prjno, prjname, prjTgtDir, blRun
  irow:=GetPrjNum(Prjhead,Prjtail)+1;

  Reset_PrjStrGrid(icol,irow,true);

  irow:=1;
  curP:=prjHead;
  while curP<>nil do
  with curP^ do
  with strgrdPrjs do
  begin
    cells[1,irow]:=prjName;
    cells[2,irow]:=prjTgtDir;
    cells[3,irow]:=RunAry[blRun];

    inc(irow);
    curP:=curP^.next;
  end;
end;

procedure TPrjDlg.Reset_PrjStrGrid(ColNum,RowNum:integer; ClearData:Boolean);
var
  i,j,k:word;
begin
   with strgrdPrjs do
   begin
     Fixedcolor:=$aaaa22;
     colCount:=ColNum;
     rowCount:=RowNum;
     ColWidths[0] :=30;
     ColWidths[1] :=100;
     ColWidths[2] :=200;
     ColWidths[3] :=50;
     cells[0,0]:='PrjNo';
     cells[1,0]:='Project Name';
     cells[2,0]:='BackUp Directory';
     cells[3,0]:='AutoBkUp';

     if ClearData then
     begin
       for j:=1 to rowcount-1 do
       begin
         cells[0,j]:=format('%d',[j]);
         cells[1,j]:='';
         cells[2,j]:='';
         cells[3,j]:='';
       end;
     end;    
   end;

end;


procedure TPrjDlg.FormShow(Sender: TObject);
begin
  FillstrgrdPrj;
end;

procedure TPrjDlg.btnDelClick(Sender: TObject);
var
  i,icol,irow:integer;
  delptr:Prjptr;
begin
  if MessageDlg('Are you sure to delete this project?', mtConfirmation,
     [mbYes, mbNo], 0) = mrNo then exit;

  delptr:=GetPrjptr(Prjhead,Prjtail,strgrdPrjs.Row-1);

  Delete_PrjRec(Prjhead,Prjtail,delptr);

  FillstrgrdPrj;
end;

procedure TPrjDlg.btnNewClick(Sender: TObject);
var
  pRec:PrjRec;
  defaultBkUpDir:string;
begin
  with pRec do
  begin
    prjName:=format('MyPrj-%d',[strgrdPrjs.row]);
    defaultBkUpDir:=AppDir+'\BkUp';
    if not DirectoryExists(defaultBkUpDir) then
     CreateDir(defaultBkUpDir);
    prjTgtDir:=defaultBkUpDir;
    blRun:=1;
    Add_PrjRec(Prjhead,Prjtail,pRec);
  end;

  FillstrgrdPrj;
end;




procedure TPrjDlg.strgrdPrjsDblClick(Sender: TObject);
var
  curP:Prjptr;
  i,lstr:integer;
  strTarget:string;
const
  SELDIRHELP = 1000;

begin
  curP:=GetPrjptr(Prjhead,Prjtail,strgrdPrjs.Row-1);

  with strgrdPrjs do
  with curP^ do
  case col of
    1:
      begin
        cells[col,row]:=prjName;
      end;
    2:
      begin
        strTarget:=prjTgtDir;
        if SelectDirectory(strTarget, [sdAllowCreate, sdPerformCreate, sdPrompt],SELDIRHELP) then
        begin
          lstr:=length(strTarget);
          for i:=lstr downto 1 do
          if strTarget[i]='\' then strTarget:=copy(strTarget,1,i-1)
          else break;
          prjTgtDir:=strTarget;
          cells[col,row]:=prjTgtDir;
        end;
      end;
    3:
      begin
        blRun:=(blRun+1) mod 2;
        cells[col,row]:=RunAry[blRun];
      end;
    end;
end;

procedure TPrjDlg.strgrdPrjsKeyPress(Sender: TObject; var Key: Char);
var
  curP:Prjptr;
begin
  with strgrdPrjs do //if this layer is not Plate then no key-in, and exit
  if col=1 then
  begin
    curP:=GetPrjptr(Prjhead,Prjtail,strgrdPrjs.Row-1);
    curP^.PrjName:=strgrdPrjs.Cells[Col,Row];
  end
  else Key:=#0;
end;

procedure TPrjDlg.OKBtnClick(Sender: TObject);
var
  curP:Prjptr;
  i:integer;
begin
  curPrj:=GetPrjptr(prjhead,Prjtail,strgrdPrjs.Row-1);


  curP:=Prjhead;
  i:=1;
  while curP<>nil do
  begin
    curP^.PrjName:=strgrdPrjs.cells[1,i];
    inc(i);
    curP:=curP^.next;
  end;

end;

end.
